function countLeadingSpaces(line) {
    const matches = line.match(/^(\s*\│\s*)*/);
    if (!matches)
        return 0;
    return matches[0].length;
}
export function parseInput(input) {
    var _a;
    const lines = input.split('\n').filter((line) => line.trim());
    const tree = [];
    const stack = [];
    for (let i = 0; i < lines.length; i++) {
        const line = lines[i];
        if (line === '.')
            continue;
        const level = countLeadingSpaces(line);
        const name = line.trim().split(' ').slice(-1)[0];
        const nextLine = lines[i + 1] || '';
        const nextLineLevel = countLeadingSpaces(nextLine);
        const type = nextLineLevel > level ? 'directory' : 'file';
        const item = type === 'directory' ? { type, name, files: [] } : { type, name };
        while (stack.length > 0 && stack[stack.length - 1].level >= level) {
            stack.pop();
        }
        if (stack.length === 0) {
            tree.push(item);
        }
        else {
            const parentItem = stack[stack.length - 1].item;
            (_a = parentItem.files) === null || _a === void 0 ? void 0 : _a.push(item);
        }
        if (item.type === 'directory') {
            stack.push({ level, item });
        }
    }
    return tree;
}
